#! /usr/bin/env bash
set -eu -o pipefail
_mountpoint=/mnt
_disk=/dev/sda
_disk_part1=/dev/sda1
trap "echo ; mount $_disk $_mountpoint && rm -v ${_mountpoint}/nulls.dd ; sysctl -w vm.drop_caches=0" INT TERM
hdparm -B 255 /dev/sda # disable APM

echo "[!] Unmounting $_disk_part1 (if mounted) ..." 
if mount | grep $_disk_part1 >/dev/null
then
    umount $_disk_part1
fi
mount -o rw,noatime $_disk_part1 $_mountpoint && \
    cd / && \
    sysctl -w vm.drop_caches=0 && \
    echo "[!] Testing write speed (cached) ..." && \
    dd if=/dev/zero bs=1M count=1024 of=${_mountpoint}/nulls.dd && \
    sync && \
    sysctl -w vm.drop_caches=3 && \
    echo "[!] Testing write speed (uncached) ..." && \
    dd if=/dev/zero bs=1M count=1024 of=${_mountpoint}/nulls.dd && \
    rm -v ${_mountpoint}/nulls.dd && sync && \
    sysctl -w vm.drop_caches=0 && \
    # unmount and do direct read measurements on $_disk
    umount $_mountpoint && \
    echo "[!] Testing cached/buffered read speeds (three times) ..." && \
    for i in 1 2 3 
    do
	hdparm -tT $_disk
    done

# remount at ~nas
#mount -o rw,noatime,nodev,nosuid,noexec $_disk_part1 /home/nas
